unit TESH_about;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, madTools, ShellApi;

type
  TformTESH_about = class(TForm)
    Bevel1: TBevel;
    Image1: TImage;
    NameLabel: TLabel;
    MadeByLabel: TLabel;
    OSDummyLabel: TLabel;
    OSLabel: TLabel;
    PMADummyLabel: TLabel;
    PMALabel: TLabel;
    CPUDummyLabel: TLabel;
    CPULabel: TLabel;
    EmailLabel: TLabel;
    EmailHotlink: TLabel;
    PJassVer: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EmailHotlinkMouseEnter(Sender: TObject);
    procedure EmailHotlinkMouseLeave(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EmailHotlinkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formTESH_about: TformTESH_about;

implementation

uses ConsoleApp;

{$R *.dfm}

procedure TformTESH_about.FormCreate(Sender: TObject);
begin
  Image1.Picture.Graphic := Application.Icon;
  OSLabel.Caption := Format('%s'+#13#10+'[Version %d.%d.%d]', [OS.description, OS.major, OS.minor, OS.build]);
  CPULabel.Caption := GetEnvironmentVariable('PROCESSOR_IDENTIFIER');
end;

procedure TformTESH_about.EmailHotlinkMouseEnter(Sender: TObject);
begin
  EmailHotlink.Font.Style := [fsUnderline];
end;

procedure TformTESH_about.EmailHotlinkMouseLeave(Sender: TObject);
begin
  EmailHotlink.Font.Style := [];
end;

function ChangeFileName(const FileName, Extension: string): string;
var
  I: Integer;
begin
  I := LastDelimiter(PathDelim + DriveDelim, FileName);
  if I = 0 then I := MaxInt;
  Result := Copy(FileName, 1, I) + Extension;
end;

procedure TformTESH_about.FormActivate(Sender: TObject);
var
  TMS: TMemoryStatus;
  Output: TStringList;
  PJPath: string;
begin
  GlobalMemoryStatus(TMS);
  PMALabel.Caption := FormatFloat('#, KB', TMS.dwAvailPhys div 1024);

  if FileExists('pjass.exe') then begin
    Output := TStringList.Create;
    ExecConsoleApp('pjass.exe', '-v', Output, nil);
    PJPath := ChangeFileName(Application.ExeName, 'pjass.exe');
    PJassVer.Caption := StringReplace(Output[0], PJPath, 'PJass', []);
    FreeAndNil(Output);
  end;
end;

procedure TformTESH_about.EmailHotlinkClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'mailto:sfilipx@gmail.com', nil, nil, SW_SHOWNORMAL);
end;

end.
