unit TESH_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, SciLexer, SciLexerMemo, SciLexerMod, Buttons,
  Menus, IniFiles, SciCallTips, SciAutoComplete, SciStreamDefault,
  SciSearchReplaceBase, SciSearchReplace, AppEvnts;

type
  TformTESH_main = class(TForm)
    HookButton: TButton;
    UpdateTimer: TTimer;
    MainPanel: TPanel;
    ButtonPanel: TPanel;
    SaveButton: TBitBtn;
    DiscardButton: TBitBtn;
    UnhookButton: TButton;
    CTMain: TScintilla;
    RefreshButton: TButton;
    PopupMenu: TPopupMenu;
    UndoMenu: TMenuItem;
    RedoMenu: TMenuItem;
    N1: TMenuItem;
    CutMenu: TMenuItem;
    CopyMenu: TMenuItem;
    PasteMenu: TMenuItem;
    N2: TMenuItem;
    SelectAllMenu: TMenuItem;
    N3: TMenuItem;
    OptionsMenu: TMenuItem;
    SciAutoComplete: TSciAutoComplete;
    SciCallTips: TSciCallTips;
    AboutMenu: TMenuItem;
    RefreshMenu: TMenuItem;
    RefreshTimer: TTimer;
    DeleteMenu: TMenuItem;
    OptionsButton: TButton;
    SyntaxCheckButton: TButton;
    SciSearchReplace: TSciSearchReplace;
    N5: TMenuItem;
    ApplicationEvents: TApplicationEvents;
    FindReplaceMenu: TPopupMenu;
    FindMenu: TMenuItem;
    FindNextMenu: TMenuItem;
    ReplaceMenu: TMenuItem;
    FindReplaceButton: TButton;
    LoadHeaderMenu: TMenuItem;
    ClearHeaderMenu: TMenuItem;
    N4: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure HookButtonClick(Sender: TObject);
    procedure UpdateTimerTimer(Sender: TObject);
    procedure UnhookButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure RefreshButtonClick(Sender: TObject);
    procedure CTMainModified(Sender: TObject; const position,
      modificationType: Integer; text: PAnsiChar; const len, linesAdded,
      line, foldLevelNow, foldLevelPrev: Integer);
    procedure MenuItemClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure OptionsMenuClick(Sender: TObject);
    procedure DiscardButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AboutMenuClick(Sender: TObject);
    procedure SyntaxCheckButtonClick(Sender: TObject);
    procedure FindMenuClick(Sender: TObject);
    procedure ReplaceMenuClick(Sender: TObject);
    procedure FindNextMenuClick(Sender: TObject);
    procedure ApplicationEventsShortCut(var Msg: TWMKey;
      var Handled: Boolean);
    procedure FindReplaceButtonClick(Sender: TObject);
    procedure CTMainKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LoadHeaderMenuClick(Sender: TObject);
    procedure ClearHeaderMenuClick(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshAll;
    procedure ParseIncludes;
    function SyntaxCheck: Boolean;
  public
    { Public declarations }
    IsIdle, DoFold, LineNum, AC, FL, RefreshOn, MegaUndo, EnableSD, TempIncludeOn: Boolean;
    UpdateI, IdleTime, RefreshI: cardinal;
    TEName: string;
    procedure DoHook(TEHandle: HWND);
  end;

  FontRec = packed record
    Color: TColor;
    LogFont: TLogFont;
  end;
  StyleData = packed record
    ForeColor, BackColor: TColor;
    IsBold, IsItalic, IsUnderline: Boolean;
  end;

var
  formTESH_main: TformTESH_main;
  tewindow, ctarea, mapinitbox, acap: hwnd;
  oldCT, includes: string;
  Styles: array[0..11] of StyleData;
  inclcount: integer;

implementation

uses TESH_options, TESH_about, TESH_colors, ConsoleApp, TESH_PJass;

{$R *.dfm}

procedure LoadFontFromStream(s: TStream; Font: TFont);
var
  fRec: FontRec;
  sz: integer;
begin
  s.read(sz, SizeOf(Integer));
  if sz = SizeOf(fRec.LogFont) then begin
    s.read(fRec, SizeOf(fRec));
    Font.Handle := CreateFontIndirect(fRec.LogFont);
    Font.Color  := fRec.Color;
  end;
end;

procedure SaveFontToStream(s: TStream; Font: TFont);
var
  fRec: FontRec;
  sz: integer;
begin
  sz := SizeOf(fRec.LogFont);
  if Windows.GetObject(Font.Handle, sz, @fRec.LogFont) > 0 then begin
    s.Write(sz, SizeOf(Integer));
    fRec.Color := Font.Color;
    s.Write(fRec, SizeOf(fRec));
  end else begin
    sz := 0;
    s.Write(sz, SizeOf(Integer));
  end;
end;

procedure TformTESH_main.ParseIncludes;
var
  SR: TSearchRec;
  FileData: TStringList;
  N: Integer;
  corestr, CallHelpStr, ACStr: string;
  DoParse, fileok: boolean;
  Output: TStringList;

  function CleanSpaces(s: string): string;
  var new: string;
  begin
    new := s;
    while (AnsiPos('  ', new) > 0) do
      new := StringReplace(new, '  ', ' ', [rfReplaceAll]);
    Result := new;
  end;

begin
  if FindFirst('includes\*.j', faAnyFile, SR) = 0 then begin
    FileData := TStringList.Create;
    repeat
      fileok := true;
      if FileExists('pjass.exe') then begin
        Output := TStringList.Create;
        ExecConsoleApp('pjass.exe', 'common.j blizzard.j "includes\'+SR.Name+'"', Output, nil);
        Output.Delete(0);
        Output.Delete(0);
        Output.Delete(0);
        Output.Delete(Output.Count-1);
        Output.Delete(Output.Count-1);
        if Output.Count <> 0 then begin
          MessageDlg('includes\'+SR.Name+': PJass check failed, parsing skipped.', mtError, [mbOK], 0);
          fileok := false;
        end;
      end;
      if fileok then begin
        includes := includes+' "includes\'+SR.Name+'"';
        inclcount := inclcount+1;
        FileData.LoadFromFile('includes\'+SR.Name);
        for N := 0 to FileData.Count-1 do begin
          corestr := Trim(CleanSpaces(FileData[N]));
          doparse := false;
          if Pos('function', corestr) = 1 then begin
            corestr := Copy(corestr, 9, Length(corestr));
            DoParse := true;
          end else if Pos('constant function', corestr) = 1 then begin
            corestr := Copy(corestr, 18, Length(corestr));
            DoParse := true;
          end;
          if DoParse then begin
            if Pos('returns nothing', corestr) > 0 then
              CallHelpStr := StringReplace(StringReplace(corestr, ' takes ', '(', []), ' returns nothing', ')', [])
            else CallHelpStr := StringReplace(StringReplace(corestr, ' takes ', '(', []), ' returns ', ')returns ', []);
            CallHelpStr := Trim(CallHelpStr);
            ACStr := Trim(Copy(corestr, 0, Pos(' takes ', corestr)));
            SciAutoComplete.AStrings.Add(ACStr);
            SciCallTips.ApiStrings.Add(CallHelpStr);
            CTMain.LanguageManager.LanguageList[1].Keywords[7].Keywords.Add(ACStr);
          end;
        end;
      end;
    until FindNext(SR) <> 0;
    FindClose(SR);
    FreeAndNil(FileData);
    includes := Trim(includes);
  end;
end;

procedure TformTESH_main.FormCreate(Sender: TObject);
var
  conf: TIniFile;
  TempStream: TMemoryStream;
  TempFont: TFont;
  N: integer;
  LoadStyle: Boolean;
begin
  CTMain.StreamClass := TSciStreamDefault;

  // load the ini file and everything in it
  conf := TIniFile.Create(ExtractFilePath(Application.ExeName)+'TESH.ini');
  with conf do begin
    Left := conf.ReadInteger('Placement', 'Left', 50);
    Top := conf.ReadInteger('Placement', 'Top', 50);

    UpdateI := ReadInteger('Options', 'UpdateRate', 500);
    IdleTime := ReadInteger('Options', 'IdleUpdate', 2000);
    RefreshI := ReadInteger('Options', 'RefreshRate', 2000);
    RefreshOn := ReadBool('Options', 'RefreshOn', false);
    TEName := ReadString('Options', 'TETitle', 'Trigger Editor');
    DoFold := ReadBool('Editor', 'DoFold', true);
    LineNum := ReadBool('Editor', 'LineNum', true);
    AC := ReadBool('Editor', 'AutoComplete', true);
    FL := ReadBool('Editor', 'FuncList', true);
    MegaUndo := ReadBool('Editor', 'NeverClearUndo', true);
    EnableSD := ReadBool('Options', 'SaveDiscard', false);

    TempStream := TMemoryStream.Create;
    ReadBinaryStream('Editor', 'LineNumFont', TempStream);
    TempFont := TFont.Create;
    LoadFontFromStream(TempStream, TempFont);
    FreeAndNil(TempStream);

    TempStream := TMemoryStream.Create;
    ReadBinaryStream('Editor', 'Font', TempStream);
    LoadFontFromStream(TempStream, CTMain.Font);
    FreeAndNil(TempStream);

    LoadStyle := ValueExists('Editor', 'StyleData');
    TempStream := TMemoryStream.Create;
    ReadBinaryStream('Editor', 'StyleData', TempStream);
    TempStream.Read(Styles, SizeOf(Styles));
    FreeAndNil(TempStream);
  end;
  FreeAndNil(conf);

  // apply some of the options right now
  if LoadStyle then for N := 0 to 11 do
  with CTMain.LanguageManager.LanguageList[1].Styles[StyleIndex[N]] do begin
    ForeColor := Styles[N].ForeColor;
    BackColor := Styles[N].BackColor;
    FontStyles := [];
    if Styles[N].IsBold then FontStyles := FontStyles+[fsBold];
    if Styles[N].IsItalic then FontStyles := FontStyles+[fsItalic];
    if Styles[N].IsUnderline then FontStyles := FontStyles+[fsUnderline];
  end
  else for N := 0 to 11 do
  with CTMain.LanguageManager.LanguageList[1].Styles[StyleIndex[N]] do begin
    Styles[N].ForeColor := ForeColor;
    Styles[N].BackColor := BackColor;
    Styles[N].IsBold := (fsBold in FontStyles);
    Styles[N].IsItalic := (fsItalic in FontStyles);
    Styles[N].IsUnderline := (fsUnderline in FontStyles);
  end;
  with CTMain.LanguageManager.LanguageList[1].Styles[18],TempFont do begin
    FontName := Name;
    FontSize := Size;
    ForeColor := Color;
    FontStyles := Style;
  end;
  FreeAndNil(TempFont);
  if not EnableSD then begin
    SaveButton.Enabled := false;
    DiscardButton.Enabled := false;
  end;

  // update intervals for the two timers
  UpdateTimer.Interval := UpdateI;
  RefreshTimer.Interval := RefreshI;

  // more options
  if not DoFold then CTMain.Folding := [];
  if not LineNum then CTMain.Gutter0.Width := 0;
  if not AC then SciAutoComplete.Disabled := True;
  if not FL then SciCallTips.Disabled := True;

  ParseIncludes;

  // set the form size so that the hook button is the only thing visible
  ClientWidth := HookButton.Width+20;
  ClientHeight := HookButton.Height+20;

  // no header loaded by default
  TempIncludeOn := False;
end;

function GetCTStuff(wnd: HWND; n: integer): BOOL; stdcall;
begin
  Result := True;
  case GetDlgCtrlID(wnd) of
    // handle of the CT box
    17: ctarea := wnd;
    // handle of the map initialization box (for checking)
    18: mapinitbox := wnd;
    // handle of the "Trigger Functions:" label (for checking)
    -1: acap := wnd;
  end;
end;

procedure TformTESH_main.DoHook(TEHandle: HWND);
var WP: WindowPlacement;
begin
  // find the ctwindow and some other stuff for later checking
  EnumChildWindows(TEHandle, @GetCTStuff, 0);
  // exit if the trigger editor or the ct area are not found
  if ((TEHandle = 0) or (ctarea = 0)) then begin
    MessageDlg('Trigger Editor window not found, make sure the World Editor is running and try again', mtError, [mbOK], 0);
    Exit;
  end;

  // show the panel with the scintilla editor
  MainPanel.Show;
  // disable the TE's CT area just in case
  EnableWindow(ctarea, false);
  // hide it as well
  ShowWindow(ctarea, SW_HIDE);
  // now move the panel
  Windows.SetParent(MainPanel.handle, TEHandle);

  // positioning of the panel - first grab the windowplacement of the
  // CT area and then apply it on the panel
  GetWindowPlacement(ctarea, @WP);
  SetWindowPlacement(MainPanel.handle, @WP);

  // enable the main timer and make sure its interval is properly set
  UpdateTimer.Enabled := True;
  UpdateTimer.Interval := UpdateI;
  // and the refresh timer if turned on in the options
  RefreshTimer.Enabled := RefreshOn;
  // the main timer is not set on an idle interval
  IsIdle := false;

  // and finally hide the main form
  Hide;
end;

procedure TformTESH_main.HookButtonClick(Sender: TObject);
begin
  // find the trigger editor
  tewindow := FindWindow(nil, PChar(TEName));

  // do the hooking
  DoHook(tewindow);
end;

procedure TformTESH_main.UpdateTimerTimer(Sender: TObject);
var
  NP: WindowPlacement;
  PanelVisible, mapiVisible, CTVisible: boolean;
  CTlength: cardinal;
  CT, newCT, acapstr: string;
begin
  // get the current size of the CT area in case it got resized and apply it
  GetWindowPlacement(ctarea, @NP);
  SetWindowPlacement(MainPanel.handle, @NP);

  // find out which components are currently visible
  MapIVisible := IsWindowVisible(mapinitbox);
  PanelVisible := IsWindowVisible(MainPanel.Handle);
  CTVisible := IsWindowVisible(ctarea);

  // grab the text from one of the labels inside the TE
  SetLength(acapstr, 20);
  SendMessage(acap, WM_GETTEXT, 21, Integer(acapstr));

  // if the custom text area is not visible in TE, hide the scintilla as well
  if (PanelVisible and ((MapIVisible = false) and (acapstr <> 'Custom &Script Code:')) ) then begin
    ShowWindow(MainPanel.Handle, SW_HIDE);
    UpdateTimer.Interval := IdleTime;
    RefreshTimer.Enabled := False;
    IsIdle := true;
  // its visible again, scintilla should reappear now
  end else if (MapIVisible or (acapstr = 'Custom &Script Code:')) then begin
    if CTVisible then
      ShowWindow(ctarea, SW_HIDE);
    if not PanelVisible then
      ShowWindow(MainPanel.Handle, SW_SHOW);
    UpdateTimer.Interval := UpdateI;
    RefreshTimer.Enabled := RefreshOn;
    IsIdle := false;
  end;
  if isidle then Exit;

  // get the text from the CT area
  CTlength := SendMessage(ctarea, WM_GETTEXTLENGTH, 0, 0);
  if CTLength <> 0 then begin
    SetLength(CT, CTlength);
    SendMessage(ctarea, WM_GETTEXT, CTlength+1, Integer(CT));
  end else CT := '';

  CTLength := CTMain.GetTextLength;
  setlength(newCT, CTLength);
  if CTLength = 0 then newCT := ''
  else CTMain.GetText(CTLength+1, PChar(newCT));

  // if it changed then that means another trigger is selected, update the scintilla
  if oldCT <> CT then begin
    oldCT := CT;
    CTMain.SetText(PChar(CT));
    if not MegaUndo then CTMain.EmptyUndoBuffer;
  end else if (not EnableSD) and (newCT <> CT) then SaveButton.OnClick(Sender);
  // disable the Save and Discard buttons if there's nothing to update
  if (SaveButton.Enabled) and (EnableSD) and (newCT = CT) then begin
    SaveButton.Enabled := False;
    DiscardButton.Enabled := False;
  end;
end;

procedure TformTESH_main.UnhookButtonClick(Sender: TObject);
begin
  // get the scintilla back
  Windows.SetParent(MainPanel.handle, formTESH_main.Handle);
  // show the original box
  ShowWindow(ctarea, SW_SHOW);
  // and enable it
  EnableWindow(ctarea, true);
  // hide the panel
  MainPanel.Hide;
  // disable both timers
  UpdateTimer.Enabled := False;
  RefreshTimer.Enabled := False;
  // show the main form again
  Show;
  // and make it active
  SetActiveWindow(Handle);
end;

procedure TformTESH_main.SaveButtonClick(Sender: TObject);
var
  Scisize: cardinal;
  Sci: string;
begin
  // fill the variable with the text from the scintilla
  Scisize := CTMain.GetTextLength;
  if scisize <> 0 then begin
    setlength(Sci, Scisize);
    CTMain.GetText(Scisize+1, PChar(Sci));
  end else sci := '';

  // apply the new text to the TE
  SendMessage(ctarea, WM_SETTEXT, Scisize+1, Integer(Sci));
  SendMessage(ctarea, WM_CHAR, Ord(' '), 0);
  SendMessage(ctarea, WM_CHAR, VK_BACK, 0);

  // keep the record for checking later and disable the buttons
  oldCT := Sci;
  SaveButton.Enabled := False;
  DiscardButton.Enabled := False;
end;

procedure TformTESH_main.RefreshButtonClick(Sender: TObject);
begin
  RefreshAll;
end;

procedure TformTESH_main.CTMainModified(Sender: TObject; const position,
  modificationType: Integer; text: PAnsiChar; const len, linesAdded, line,
  foldLevelNow, foldLevelPrev: Integer);
begin
  if EnableSD then begin
    // text modified, enable the buttons
    SaveButton.Enabled := true;
    DiscardButton.Enabled := true;
  end;
end;

procedure TformTESH_main.MenuItemClick(Sender: TObject);
begin
  with CTMain do
    case (Sender as TMenuItem).Tag of
      0: Undo;
      1: Redo;
      2: Cut;
      3: Copy;
      4: Paste;
      5: DeleteBack;
      6: SelectAll;
    end;
end;

procedure TformTESH_main.PopupMenuPopup(Sender: TObject);
begin
  UndoMenu.Enabled := CTMain.CanUndo;
  RedoMenu.Enabled := CTMain.CanRedo;
  PasteMenu.Enabled := CTMain.CanPaste;
  ClearHeaderMenu.Enabled := TempIncludeOn;
end;

procedure TformTESH_main.OptionsMenuClick(Sender: TObject);
begin
  formTESH_Options.Show;
  RefreshTimer.Enabled := False;
end;

procedure TformTESH_main.DiscardButtonClick(Sender: TObject);
var
  CT: string;
  CTLength: cardinal;
  scroll: integer;
begin
  // get the current scroll position so that it can be restored later
  scroll := CTMain.GetCurrentScrollPosition;

  // get the current text from the TE
  CTlength := SendMessage(ctarea, WM_GETTEXTLENGTH, 0, 0);
  SetLength(CT, CTlength);
  SendMessage(ctarea, WM_GETTEXT, CTlength+1, Integer(CT));

  // apply it to the scintilla
  CTMain.SetText(PChar(CT));

  // return the scroll position
  CTMain.LineScroll(0, scroll);
end;

procedure TformTESH_main.RefreshAll;
begin
  // repaint all injected components
  MainPanel.Repaint;
  SaveButton.Repaint;
  DiscardButton.Repaint;
  UnhookButton.Repaint;
  SyntaxCheckButton.Repaint;
  RefreshButton.Repaint;
  OptionsButton.Repaint;
  CTMain.Repaint;
  ButtonPanel.Repaint;
end;

procedure TformTESH_main.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  conf: TIniFile;
  TempStream: TMemoryStream;
  TempFont: TFont;
begin
  // write the options to the ini file
  conf := TIniFile.Create(ExtractFilePath(Application.ExeName)+'TESH.ini');
  with conf do begin
    WriteInteger('Placement', 'Left', Left);
    WriteInteger('Placement', 'Top', Top);
    WriteInteger('Options', 'UpdateRate', UpdateI);
    WriteInteger('Options', 'IdleUpdate', IdleTime);
    WriteInteger('Options', 'RefreshRate', RefreshI);
    WriteBool('Options', 'RefreshOn', RefreshOn);
    WriteBool('Editor', 'DoFold', DoFold);
    WriteBool('Editor', 'LineNum', LineNum);
    WriteBool('Editor', 'AutoComplete', AC);
    WriteBool('Editor', 'FuncList', FL);
    WriteBool('Editor', 'NeverClearUndo', MegaUndo);
    WriteString('Options', 'TETitle', TEName);
    WriteBool('Options', 'SaveDiscard', EnableSD); 

    TempStream := TMemoryStream.Create;
    TempFont := TFont.Create;
    with formTESH_Main.CTMain.LanguageManager.LanguageList[1].Styles[18],TempFont do begin
      Name := FontName;
      Size := FontSize;
      Color := ForeColor;
      Style := FontStyles;
    end;
    SaveFontToStream(TempStream, TempFont);
    FreeAndNil(TempFont);
    TempStream.Position := 0;
    WriteBinaryStream('Editor', 'LineNumFont', TempStream);
    FreeAndNil(TempStream);

    TempStream := TMemoryStream.Create;
    SaveFontToStream(TempStream, CTMain.Font);
    TempStream.Position := 0;
    WriteBinaryStream('Editor', 'Font', TempStream);
    FreeAndNil(TempStream);

    TempStream := TMemoryStream.Create;
    TempStream.Write(Styles, SizeOf(Styles));
    TempStream.Position := 0;
    WriteBinaryStream('Editor', 'StyleData', TempStream);
    FreeAndNil(TempStream);
  end;
  FreeAndNil(conf);
end;

procedure TformTESH_main.AboutMenuClick(Sender: TObject);
begin
  formTESH_about.Show;
end;

procedure TformTESH_main.SyntaxCheckButtonClick(Sender: TObject);
begin
  SyntaxCheck;
end;

procedure TformTESH_main.FindMenuClick(Sender: TObject);
begin
  SciSearchReplace.ShowSearchDialog;
end;

procedure TformTESH_main.ReplaceMenuClick(Sender: TObject);
begin
  SciSearchReplace.ShowReplaceDialog;
end;

procedure TformTESH_main.FindNextMenuClick(Sender: TObject);
begin
  SciSearchReplace.DoSearchReplaceText(false, false);
end;

procedure TformTESH_main.ApplicationEventsShortCut(var Msg: TWMKey;
  var Handled: Boolean);
begin
  if (GetKeyState(VK_CONTROL) < 0) and (not GetKeyState(VK_SHIFT) < 0)
  and (not GetKeyState(VK_MENU) < 0) then begin
    if Msg.CharCode = Ord('F') then
      SciSearchReplace.ShowSearchDialog
    else if Msg.CharCode = Ord('R') then
      SciSearchReplace.ShowReplaceDialog;
    Handled := True;
  end;
end;

procedure TformTESH_main.FindReplaceButtonClick(Sender: TObject);
begin
  FindReplaceMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TformTESH_main.CTMainKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F3 then FindNextMenu.OnClick(Sender);
end;

procedure TformTESH_main.LoadHeaderMenuClick(Sender: TObject);
begin
  if not SyntaxCheck then Exit;
  CTMain.SaveToFile('header.j');
  TempIncludeOn := True;
end;

procedure TformTESH_main.ClearHeaderMenuClick(Sender: TObject);
begin
  DeleteFile('header.j');
  TempIncludeOn := false;
end;

function TformTESH_main.SyntaxCheck: Boolean;
var
  Output: TStringList;
  N: integer;
  param: string;
begin
  Result := False;
  if not FileExists('pjass.exe') then MessageDlg('PJass not found, make sure it''s in the same directory as TESH.exe and try again.', mtError, [mbOK], 0)
  else if not FileExists('common.j') then MessageDlg('common.j not found, make sure it''s in the same directory as TESH.exe and try again.', mtError, [mbOK], 0)
  else if not FileExists('blizzard.j') then MessageDlg('blizzard.j not found, make sure it''s in the same directory as TESH.exe and try again.', mtError, [mbOK], 0)
  else begin
    CTMain.SaveToFile('tempfile.j');
    Output := TStringList.Create;
    if not TempIncludeOn then param := 'common.j blizzard.j '+includes+' tempfile.j'
    else param := 'common.j blizzard.j '+includes+' header.j tempfile.j';
    ExecConsoleApp('pjass.exe', param, Output, nil);
    Output.Delete(0);
    Output.Delete(0);
    Output.Delete(Output.Count-1);
    Output.Delete(Output.Count-1);
    if inclcount > 0 then for N := 0 to inclcount-1 do Output.Delete(0);
    if TempIncludeOn then Output.Delete(0);
    if Output.Count < 2 then begin
      ShowMessage('Parse successful');
      Result := True;
    end else with formTESH_PJass do begin
      Output.Delete(Output.Count-1);
      if Output.Count = 1 then Label1.Caption := '1 compile error'
      else Label1.Caption := Format('%d compile errors', [Output.Count]);
      for N := 0 to Output.Count-1 do
        Output[N] := StringReplace(Output[N], 'tempfile.j:', 'Line ', []);
      ListBox1.Items := Output;
      RichEdit1.Lines := CTMain.Lines;
      Show;
    end;
    FreeAndNil(Output);
    SysUtils.DeleteFile('tempfile.j');
  end;
end;

end.
